
#include <ArduinoBLE.h>
#define SERVICE_UUID "19B10000-E8F2-537E-4F6C-D104768A1214"
#define DIGITAL_READ_CHARACT_UUID "19B10001-E8F2-537E-4F6C-D104768A1214"
#define DIGITAL_WRITE_CHARACT_UUID "19B10002-E8F2-537E-4F6C-D104768A1214"

byte value;
            
void setup() {
  value = 0;
  Serial.begin(9600);
  while (!Serial);
  if (!BLE.begin()) {
    Serial.println("* Starting Bluetooth® Low Energy module failed!");
    while (1);
  }
  BLE.setLocalName("Nano 33 BLE (Central)"); 
  BLE.advertise();

}      
            
void connectToPeripheral() {
  BLEDevice peripheral;
  Serial.println("recherche du périphérique");
  do
  {
    BLE.scanForUuid(SERVICE_UUID);
    peripheral = BLE.available();
  } while (!peripheral);

  if (peripheral) {
    Serial.println("périphérique découvert");
    Serial.print("adresse : ");
    Serial.println(peripheral.address());
    Serial.print("Nom du périphérique : ");
    Serial.println(peripheral.localName());
    Serial.print(" UUID publié : ");
    Serial.println(peripheral.advertisedServiceUuid());
    Serial.println(" ");
    BLE.stopScan();
    controlPeripheral(peripheral);

    }
}
            
void controlPeripheral(BLEDevice peripheral) {
   uint8_t digital;
    if (peripheral.connect()) {
      Serial.println("connexion au périphérique ");
      Serial.println(" ");
    } else {
      Serial.println("échec de la connexion au périphérique ");
      Serial.println(" ");
      return;
    }
    Serial.println("recherche des attributs du périphérique");
    if (peripheral.discoverAttributes()) {
      Serial.println("attributs du périphériques trouvés ");
      Serial.println(" ");
    } else {
      Serial.println("échec de la recherche d'attributs");
      Serial.println(" ");
      peripheral.disconnect();
      return;
    }
    BLECharacteristic digitalReadChar = peripheral.characteristic(DIGITAL_READ_CHARACT_UUID);
    if (!digitalReadChar) {
      Serial.println("le périphérique n'a pas de caractéristique digitalReadChar");
      peripheral.disconnect();
      return;
    }
    else if (!digitalReadChar.canSubscribe()) {
      Serial.println("simple key characteristic is not subscribable!");
      peripheral.disconnect();
      return;
    } 
    else if (!digitalReadChar.subscribe()) {
    Serial.println("subscription failed!");
    peripheral.disconnect();
    return;
  }
  
  BLECharacteristic digitalWriteChar = peripheral.characteristic(DIGITAL_WRITE_CHARACT_UUID);
  if (!digitalWriteChar) {
      Serial.println("le périphérique n'a pas de caractéristique digitalWriteChar");
      peripheral.disconnect();
      return;
    }
    
    while (peripheral.connected()) {
        delay(1000);
        if (value==0) value=1;
        else value=0;
        digitalWriteChar.writeValue(value);
        if (digitalReadChar.valueUpdated()) {
          uint8_t digital;
          digitalReadChar.readValue(digital);
          Serial.print("Digital = ");
          Serial.println(digital);
        }
    }
  }

  

     
            